set_time_format -unit ns -decimal_places 3

create_clock -name {CLK} -period 10.000 -waveform { 0.000 5.000 } [get_ports {clk}]   
create_clock -name {REF_CLK} -period 8.000 -waveform { 0.000 4.000 } [get_ports {ref_clk_to_the_triple_speed_ethernet}]

derive_pll_clocks

#create generated clock
create_generated_clock -name {tx_div_clk_25} -divide_by 5 -source [get_ports {ref_clk_to_the_triple_speed_ethernet}] \
								[get_registers {*|clock_divider:clock_div_tx_u0|CLK_DIV_OUT}]  
																
create_generated_clock -name {tx_div_clk_2_5} -divide_by 50 -add -source [get_ports {ref_clk_to_the_triple_speed_ethernet}] \
								[get_registers {*|clock_divider:clock_div_tx_u0|CLK_DIV_OUT}]  

create_generated_clock -name {rx_div_clk_25} -divide_by 5 \
	-source	[get_pins {tse_ref_design_top_u0|the_sgmii_pcs_0|sgmii_pcs_0|altera_tse_pcs_pma_inst|the_altera_tse_pma_lvds_rx|*|auto_generated|rx[0]|clk0}] \
	[get_registers {*|clock_divider:clock_div_rx_u0|CLK_DIV_OUT}]  
	
create_generated_clock -name {rx_div_clk_2_5} -divide_by 50 -add \
	-source [get_pins {tse_ref_design_top_u0|the_sgmii_pcs_0|sgmii_pcs_0|altera_tse_pcs_pma_inst|the_altera_tse_pma_lvds_rx|*|auto_generated|rx[0]|clk0}] \
	[get_registers {*|clock_divider:clock_div_rx_u0|CLK_DIV_OUT}]  
	
		
#for SIV GX in LVDS
set_clock_groups -asynchronous	-group {REF_CLK} -group {tse_ref_design_top_u0|pll|sd1|pll7|clk[0]}
set_clock_groups -asynchronous	-group {CLK} \
								-group {tse_ref_design_top_u0|pll|sd1|pll7|clk[0]}

set_clock_groups -asynchronous	-group {tse_ref_design_top_u0|pll|sd1|pll7|clk[0]} \
								-group {REF_CLK} \
								-group {tse_ref_design_top_u0|the_sgmii_pcs_0|sgmii_pcs_0|altera_tse_pcs_pma_inst|the_altera_tse_pma_lvds_rx|*|auto_generated|pll|clk[0] \
										tse_ref_design_top_u0|the_sgmii_pcs_0|sgmii_pcs_0|altera_tse_pcs_pma_inst|the_altera_tse_pma_lvds_rx|*|auto_generated|rx[0]|clk0}	
									
										
										
set_clock_groups -asynchronous 	-group {CLK} \
								-group {REF_CLK} \
								-group {tse_ref_design_top_u0|the_triple_speed_ethernet_0|altera_tse_mac_pcs_pma_inst|the_altera_tse_pma_lvds_rx|*|auto_generated|rx[0]|clk0}										
																												
set_clock_groups -asynchronous	-group {tx_div_clk_25} \
								-group {tx_div_clk_2_5} \
								-group {rx_div_clk_25} \
								-group {rx_div_clk_2_5}

set_clock_groups -asynchronous	-group {REF_CLK} \
								-group {rx_div_clk_25 \
										rx_div_clk_2_5}
										
set_clock_groups -asynchronous	-group {REF_CLK} \
								-group {tx_div_clk_25 \
										tx_div_clk_2_5}	
																			
#set false path on clock divider																					
set_clock_groups -asynchronous	-group {tse_ref_design_top_u0|the_sgmii_pcs_0|sgmii_pcs_0|altera_tse_pcs_pma_inst|the_altera_tse_pma_lvds_rx|*|auto_generated|rx[0]|clk0} \
								-group {tse_ref_design_top_u0|pll|sd1|pll7|clk[0]} \
								-group {rx_div_clk_25 \
										rx_div_clk_2_5 \
										tx_div_clk_25 \  
										tx_div_clk_2_5}																		
					
#set_false_path -from {CLK} -to {tse_ref_design_top_u0|the_sgmii_pcs_0|sgmii_pcs_0|altera_tse_pcs_pma_inst|the_altera_tse_pma_lvds_rx|*|auto_generated|rx[0]|clk0}										
																						
set_false_path -from [get_registers {*|altera_tse_a_fifo_24:U_DSW|altera_tse_gray_cnt:U_RD|g_out[*]}] -to [get_registers {*|altera_tse_a_fifo_24:U_DSW|rd_g_wptr[*]}]
set_false_path -from [get_registers {*|altera_tse_a_fifo_24:U_DSW|altera_tse_gray_cnt:U_RD|b_out[*]}] -to [get_registers {*|altera_tse_a_fifo_24:U_DSW|rd_g_wptr[*]}]
set_false_path -from [get_registers {*|altera_tse_a_fifo_24:U_DSW|altera_tse_gray_cnt:U_WRT|g_out[*]}] -to [get_registers {*|altera_tse_a_fifo_24:U_DSW|wr_g_rptr[*]}]
set_false_path -from [get_registers {*|altera_tse_top_sgmii*:U_SGMII|altera_tse_colision_detect:U_COL|state*}] -to [get_registers {*|altera_tse_fifoless_mac_tx:U_TX|gm_rx_col_reg*}]

set_false_path	-from [get_registers {tse_ref_design_top:tse_ref_design_top_u0|sgmii_pcs_0:the_sgmii_pcs_0|sgmii_pcs:sgmii_pcs_0|altera_tse_pcs_pma:altera_tse_pcs_pma_inst|altera_tse_top_1000_base_x:altera_tse_top_1000_base_x_inst|altera_tse_top_sgmii:U_SGMII|altera_tse_top_rx_converter:U_RXCV|altera_tse_mii_tx_if_pcs:U_RXMII|mii_tx*}] \
				-to	[get_registers {tse_ref_design_top:tse_ref_design_top_u0|pcs_loopback_wrapper_0:the_pcs_loopback_wrapper_0|pcs_loopback_wrapper:pcs_loopback_wrapper_0|pcs_loopback_mux:pcs_loopback_mux_u0|altera_std_synchronizer_bundle:mii_rx_if_sync_u0|altera_std_synchronizer:sync[*].u|din_s1}]
				    
