#include "elem.h"
#include "unistd.h"
#include "test_control.h"
#include "helpers.h"
#include "bool_check.h"
#include "system.h"
#include "io.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hardware_def.h"


extern struct gTestStruct Gtest;
extern char gDisplay[];
extern struct menu report;
extern char input_string[MAX_COMM_SIZE];
extern int displayReport(char *output, void *thing);
static char * cprmpt = "% ";
extern struct gTestStruct * curr_active_test_ptr;

extern int elemBufferForDisplay(char * buffer, int buffer_size, struct elem * item, int no_options);
extern int elemGetOptionCount(struct elem * item);
extern int menuPrintElem(int number, char *display);

static struct console
{
  unsigned int reg_result;
  int display;
} gConsole;

static struct console * console_ptr = &gConsole;
static const char * terminate = "x";
static const char * help = "?";

//void displayMemoryMap(char *output, void *thing)
//{
//  int pos=0;
//  pos = sprintf(output, "Memory Map:\n");
//  pos += sprintf(output+pos, "%08x - %08x %s\n", ONCHIP_MEM_BASE, ONCHIP_MEM_BASE+ONCHIP_MEM_SPAN, ONCHIP_MEM_NAME);
//  pos += sprintf(output+pos, "%08x - %08x %s\n", JTAG_UART_BASE, JTAG_UART_BASE+JTAG_UART_SPAN, JTAG_UART_NAME);
//  pos += sprintf(output+pos, "%08x - %08x %s\n", PLL_BASE, PLL_BASE+PLL_SPAN, PLL_NAME);
//  pos += sprintf(output+pos, "%08x - %08x %s\n", PIO_BASE, PIO_BASE+PIO_SPAN, PIO_NAME);
//  pos += sprintf(output+pos, "%08x - %08x %s\n", PIO_1_BASE, PIO_1_BASE+PIO_1_SPAN, PIO_1_NAME);
//  pos += sprintf(output+pos, "%08x - %08x %s\n", PIO_2_BASE, PIO_2_BASE+PIO_2_SPAN, PIO_2_NAME);
//  pos += sprintf(output+pos, "%08x - %08x %s\n", PIO_3_BASE, PIO_3_BASE+PIO_3_SPAN, PIO_3_NAME);
//  pos += sprintf(output+pos, "%08x - %08x %s\n", TRIPLE_SPEED_ETHERNET_0_BASE, TRIPLE_SPEED_ETHERNET_0_BASE+TRIPLE_SPEED_ETHERNET_0_SPAN, TRIPLE_SPEED_ETHERNET_0_NAME);
//  pos += sprintf(output+pos, "%08x - %08x %s\n", TRIPLE_SPEED_ETHERNET_1_BASE, TRIPLE_SPEED_ETHERNET_1_BASE+TRIPLE_SPEED_ETHERNET_1_SPAN, TRIPLE_SPEED_ETHERNET_1_NAME);
////  pos += sprintf(output+pos, "%08x - %08x %s\n", ETH_GEN_1_BASE, ETH_GEN_1_BASE+ETH_GEN_1_SPAN, ETH_GEN_1_NAME);
////  pos += sprintf(output+pos, "%08x - %08x %s\n", ETH_MON_1_BASE, ETH_MON_1_BASE+ETH_MON_1_SPAN, ETH_MON_1_NAME);
//  pos += sprintf(output+pos, "%08x - %08x %s\n", ETH_MON_0_BASE, ETH_MON_0_BASE+ETH_MON_0_SPAN, ETH_MON_0_NAME);
//  pos += sprintf(output+pos, "%08x - %08x %s\n", ETH_GEN_0_BASE, ETH_GEN_0_BASE+ETH_GEN_0_SPAN, ETH_GEN_0_NAME);
//}

//jier
void displayMemoryMap(char *output, void *thing)
{
  	int pos=0;
  	
  	pos = sprintf(output, "Memory Map:\n");
  	pos += sprintf(output+pos, "%08x - %08x %s\n", ONCHIP_MEMORY_BASE, ONCHIP_MEMORY_BASE+ONCHIP_MEMORY_SPAN, ONCHIP_MEMORY_BASE);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", JTAG_UART_0_BASE, JTAG_UART_0_BASE+JTAG_UART_0_SPAN, JTAG_UART_0_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", PLL_BASE, PLL_BASE+PLL_SPAN, PLL_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", PIO_0_BASE, PIO_0_BASE+PIO_0_SPAN, PIO_0_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", PIO_1_BASE, PIO_1_BASE+PIO_1_SPAN, PIO_1_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", PIO_2_BASE, PIO_2_BASE+PIO_2_SPAN, PIO_2_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", PIO_3_BASE, PIO_3_BASE+PIO_3_SPAN, PIO_3_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", ETH_MON_0_BASE, ETH_MON_0_BASE+ETH_MON_0_SPAN, ETH_MON_0_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", ETH_GEN_0_BASE, ETH_GEN_0_BASE+ETH_GEN_0_SPAN, ETH_GEN_0_NAME);
  	//pos += sprintf(output+pos, "%08x - %08x %s\n", ETH_GEN_1_BASE, ETH_GEN_1_BASE+ETH_GEN_1_SPAN, ETH_GEN_1_NAME);
	//pos += sprintf(output+pos, "%08x - %08x %s\n", ETH_MON_1_BASE, ETH_MON_1_BASE+ETH_MON_1_SPAN, ETH_MON_1_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", TSE0_BASE, TSE0_BASE+TRIPLE_SPEED_ETHERNET_0_SPAN, TRIPLE_SPEED_ETHERNET_0_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", TSE1_BASE, TSE1_BASE+TRIPLE_SPEED_ETHERNET_1_SPAN, TRIPLE_SPEED_ETHERNET_1_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", PCS1_BASE, PCS1_BASE+SGMII_PCS_0_SPAN, SGMII_PCS_0_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", PCS_LOOPBACK_BASE, PCS_LOOPBACK_BASE+PCS_LOOPBACK_WRAPPER_0_SPAN, PCS_LOOPBACK_WRAPPER_0_NAME);
  	pos += sprintf(output+pos, "%08x - %08x %s\n", AVALON_ST_LOOPBACK_BASE, AVALON_ST_LOOPBACK_BASE+AVALON_ST_LOOPBACK_SOPC_WRAPPER_0_SPAN, AVALON_ST_LOOPBACK_SOPC_WRAPPER_0_NAME);
}


void consolePrintTerminateHelp()
{
  memset(gDisplay, 0, sizeof(char)*BUFFER_SIZE);
  sprintf(gDisplay, "%s", "x - Terminates Console Session\n    (don't type it unless you MEAN it!)");
  menuPrintElem(0, (char*)&gDisplay);
}
void consolePrintHelpHelp()
{
  memset(gDisplay, 0, sizeof(char)*BUFFER_SIZE);
  sprintf(gDisplay, "%s", "? - Lists all console commands\n    (<command>? - Prints help for a command)");
  menuPrintElem(0, (char*)&gDisplay);
}

void displayConsoleText(char *output, void *thing)
{
    int pos=0;
    char * console_text =
    "The console mode allows you to use the command line to enter commands. ";
    pos = sprintf(output, console_text);
}

void consoleListAllCommands(void)
{
  struct menu * menu_ptr=0;
  int num_elems=0;
  int curr_elem=0;
  struct elem * item=0;
  menu_ptr = menuGetFirst();
  int pos=0;

  num_elems=menuGetElemArraySize(menu_ptr);
  memset(gDisplay, 0, sizeof(char)*BUFFER_SIZE);

  pos=sprintf(gDisplay, "%s", "Commands: \n");
  while(menu_ptr)
  {
    for(curr_elem=1;curr_elem<=num_elems;curr_elem++)
    {
      item = menuGetElemByIndex(menu_ptr, curr_elem);
      if(item->active_console==TRUE)
        pos+=sprintf(gDisplay+pos, "-- %s\n", item->key_name);
    }

    menu_ptr = menuGetNext(menu_ptr);
  }
  // output our special commands
  pos+=sprintf(gDisplay+pos, "-- %s\n", "x");
  pos+=sprintf(gDisplay+pos, "-- %s", "?");
  menuPrintElem(0, (char*)&gDisplay);
}

int consoleProcessInput(char *input)
{
  int ret_val = TRUE;
  int num = 0;
  struct menu * menu_ptr=0;
  struct elem * item=0;
  int size =0;
  int done = FALSE;

  /* Find the command entered by the user */
  if((num=delimitWhiteSpace(&input))==0)
    return TRUE;

  if(strncmp(terminate, input, strlen(input))==0)
    ret_val = FALSE;
  else if (strncmp(help, input, strlen(input))==0)
    consoleListAllCommands();
  else if (strncmp("x?", input, strlen(input))==0)
    consolePrintTerminateHelp();
  else if (strncmp("??", input, strlen(input))==0)
    consolePrintHelpHelp();
  else
  {
    int num_elems=0;
    menu_ptr = menuGetFirst();
    int pos=0;
    int i=0;

    while(done==FALSE)
    {
        //menu_name = menuGetKeyName(menu_ptr);
        num_elems=menuGetElemArraySize(menu_ptr);

        while((num_elems)&&(done==FALSE))
        {
            item = menuGetElemByIndex(menu_ptr, num_elems);

            if((*(item->key_name)!=0)&&(item->active_console==TRUE)&&(strncmp(item->key_name, input, strlen(item->key_name)))==0)
            {
                if(strncmp(help,input+strlen(item->key_name), strlen(help))==0)
                {
                    memset(gDisplay, 0, sizeof(char)*BUFFER_SIZE);
                    pos=elemBufferForDisplay(gDisplay, BUFFER_SIZE, item, TRUE);
                    done=TRUE;
                    if((size=elemGetOptionCount(item)))
                    {
                        if(strncmp((char*)elemGetOptionByIndex(item,size),USER_INPUT_TOKEN, sizeof(USER_INPUT_TOKEN))!=0)
                        {
                            pos+=sprintf(gDisplay+pos, "\n%s", "Allowed Values: ");
                            for(i=1;i<=size;i++)
                               pos+=sprintf(gDisplay+pos,"%s ",(char*)elemGetOptionByIndex(item,i));
                        }
                    }
                    menuPrintElem(0, (char*)&gDisplay);
                }
                else
                {
                  if(item->validate_input)
                      item->validate_input(input+num, item->thing);
                  done = TRUE;
                  ret_val = TRUE;

                  num=0;
                  if(item->dynamic_description)
                  {
                      memset(gDisplay, 0, sizeof(char)*BUFFER_SIZE);
                      num = item->dynamic_description((char*)&gDisplay, item->thing);
                  }
                  if(num>0)
                      menuPrintElem(0, (char*)&gDisplay);
                }
            }else
                num_elems--;
        }


        if((menu_ptr = menuGetNext(menu_ptr))==FALSE)
            done=TRUE;
    }

  }
  return(ret_val);
}

int enterConsole(char *input, void *thing)
{
  int ret_val = TRUE;
  int console_active = TRUE;

  printString("\nEntering console mode...",1);
  printString("\n'x'<Enter> exits console mode",1);
  printString("\n'?'<Enter> brings up list of commands\n",1);

  printString(cprmpt,1);

  while(console_active == TRUE)
  {
    /* get input */
    if(getInputLine(input_string, MAX_COMM_SIZE, stdin, stdout))
    {
      /* process command */
      nullCRLF(input_string);
      console_active = consoleProcessInput(input_string);

      printString(cprmpt,1);

    }
  }
  printString("\n", 1);
  return(ret_val);
}

int valAndSetRegister(char *input, void *thing)
{
  char * addr_string=0;
  char * offset_string=0;
  char * value_string=0;
  int num=0;
  int base=10;
  unsigned int addr=-1;
  unsigned int value=-1;
  unsigned int offset=-1;
  int *do_offset = (int*)thing;

  addr_string=input;
  if((num=delimitWhiteSpace(&input)))
  {
    if(*(addr_string+num)!=0)
    {
      offset_string=addr_string+num;
      if((num=delimitWhiteSpace(&offset_string)))
      {
        if(*(offset_string+num)!=0)
          value_string=offset_string+num;
      }

      if(do_offset==FALSE)
      {
        value_string = offset_string;
        offset_string = 0;
      }
    }
  }

  if(addr_string>0)
  {
    // calculate base
    base=10;
    if(validateHexString(addr_string)==TRUE)
    {
      base=16;
      stripLeadingHex(&addr_string);
    }
    addr=strtoul(addr_string,0,base);

    // calculate offset
    offset = 0;
    if(do_offset && offset_string)
    {
      base=10;
      if(validateHexString(offset_string)==TRUE)
      {
        base=16;
        stripLeadingHex(&offset_string);
      }
      offset=strtoul(offset_string,0,base);
    }

    // calculate value
    if(value_string)
    {
      base = 10;
      if(validateHexString(value_string)==TRUE)
      {
        base=16;
        stripLeadingHex(&value_string);
      }
      value=strtoul(value_string,0,base);
    }


    if((addr_string!=0) && (value_string!=0))
    {
//      console_ptr->reg_result = reg_write(addr+offset,value);
      IOWR_32DIRECT(addr, offset, value);
      return TRUE;
    }
    else
    {
//      console_ptr->reg_result = reg_read(addr+offset);
      console_ptr->reg_result = IORD_32DIRECT(addr, offset);
      console_ptr->display=TRUE;
      return TRUE;
    }
  }
  else
      return TRUE;
}

int valAndSetRegister16 (char *input, void *thing)
{
  char * addr_string=0;
  char * offset_string=0;
  char * value_string=0;
  int num=0;
  int base=10;
  unsigned int addr=-1;
  unsigned int value=-1;
  unsigned int offset=-1;
  int *do_offset = (int*)thing;

  addr_string=input;
  if((num=delimitWhiteSpace(&input)))
  {
    if(*(addr_string+num)!=0)
    {
      offset_string=addr_string+num;
      if((num=delimitWhiteSpace(&offset_string)))
      {
        if(*(offset_string+num)!=0)
          value_string=offset_string+num;
      }

      if(do_offset==FALSE)
      {
        value_string = offset_string;
        offset_string = 0;
      }
    }
  }

  if(addr_string>0)
  {
    // calculate base
    base=10;
    if(validateHexString(addr_string)==TRUE)
    {
      base=16;
      stripLeadingHex(&addr_string);
    }
    addr=strtoul(addr_string,0,base);

    // calculate offset
    offset = 0;
    if(do_offset && offset_string)
    {
      base=10;
      if(validateHexString(offset_string)==TRUE)
      {
        base=16;
        stripLeadingHex(&offset_string);
      }
      offset=strtoul(offset_string,0,base);
    }

    // calculate value
    if(value_string)
    {
      base = 10;
      if(validateHexString(value_string)==TRUE)
      {
        base=16;
        stripLeadingHex(&value_string);
      }
      value=strtoul(value_string,0,base);
    }


    if((addr_string!=0) && (value_string!=0))
    {
//      console_ptr->reg_result = reg_write(addr+offset,value);
      IOWR_16DIRECT(addr, offset, value);
      return TRUE;
    }
    else
    {
//      console_ptr->reg_result = reg_read(addr+offset);
      console_ptr->reg_result = IORD_16DIRECT(addr, offset);
      console_ptr->display=TRUE;
      return TRUE;
    }
  }
  else
      return TRUE;
}

int displayRegister(char *output, void *thing)
{
  int pos=0;
  if(console_ptr->display==TRUE)
  {
    pos= sprintf(output, "0x%08x", console_ptr->reg_result);
  }
  return(pos);
}


/* Menu Creation */



struct elem console_menu[] =
{
  {"console_text","%s",
    (void*)&displayConsoleText,0,TRUE,FALSE,0,0,FALSE},
  {"console","\nConsole",FALSE,FALSE,TRUE,TRUE,(char* []){"Enter console mode",0},&enterConsole,FALSE,},
  {"oreg32",
   "\nRegister - R/W a 32 bit register (with offset)."\
   "\n- oreg32 <base> <offset> - reads a register at base+offset"\
   "\n- oreg32 <base> <offset> <value> - writes <value> to a register at base+offset"\
   "\n-(i.e. oreg 0x100 0x4 0x00aa : will write register at 0x100+0x4 with 0x00aa)",
   &displayRegister,(void*)1,FALSE,FALSE,0,&valAndSetRegister,TRUE},
  {"reg32",
   "\nRegister - R/W a 32 bit register."\
   "\n- reg32 <base> - reads a register at base"\
   "\n- reg32 <base> <value> - writes <value> to a register at base"\
   "\n-(i.e. reg 0x100 0x00aa : will write register at 0x100+0x4 with 0x00aa)",
   &displayRegister,
   0,FALSE,FALSE,FALSE,&valAndSetRegister,TRUE},
   {"oreg16",
   "\nRegister - R/W a 16 bit register (with offset)."\
   "\n- oreg16 <base> <offset> - reads a register at base+offset"\
   "\n- oreg16 <base> <offset> <value> - writes <value> to a register at base+offset"\
   "\n-(i.e. oreg 0x100 0x2 0x00aa : will write register at 0x100+0x2 with 0x00aa)",
   &displayRegister,(void*)1,FALSE,FALSE,0,&valAndSetRegister16,TRUE},
   {"reg16",
   "\nRegister - R/W a 16 bit register."\
   "\n- reg16 <base> - reads a register at base"\
   "\n- reg16 <base> <value> - writes <value> to a register at base"\
   "\n-(i.e. reg 0x100 0x00aa : will write register at 0x100+0x2 with 0x00aa)",
   &displayRegister,
   0,FALSE,FALSE,FALSE,&valAndSetRegister16,TRUE},
   {
   "test",
   "\nTest Configuration- Prints out test parameters",
   &displayReport,
   &curr_active_test_ptr,
   FALSE,
   FALSE,
   0,
   0,
   TRUE,
   },
   {
   "map",
   "\nMemory Map - Prints out memory map for system",
   (void*)&displayMemoryMap,
   0,
   FALSE,
   FALSE,
   0,
   0,
   TRUE,
   },
   LIST_MENUS
};

struct menu console = {
   0,
   "console_menu",
   "Console Menu",
   console_menu,
   sizeof(console_menu)/sizeof(struct elem)
};

