#ifndef ELEM_DEF_H_
#define ELEM_DEF_H_


#define MAX_COMM_SIZE 64
#define BUFFER_SIZE 1024
#define NULL_PLACE_HOLDER (void*)-255
#define USER_INPUT_TOKEN "<user specified>"
#define WIDTH 70
#define NSYM ") "

// parse nodes...
struct parse_node{
  char command[MAX_COMM_SIZE];
  int index;
  int * looking_for_array;  
};

struct elem{
  char * key_name;
  char * static_description;
  int (*dynamic_description)(char * display, void * thing);
  void * thing;
  int active;
  int enumerate;
  char ** options;
  int (*validate_input)(char * input, void * thing);
  int active_console;
};

// menu
struct menu{
  struct menu * next;
  char * key_name;
  char * static_description;
  struct elem * elem_array;
  int elem_array_size;
};

int ListMenus(char * command, void * thing);
void SetMenu(char * input, void * thing);
void menuDisplayActive(void);
int menuGetIndexByString(const int searchmajor, const char * string);
int menuGetStringByIndex(const int searchmajor, const int index, char *string);
void parseNodeInit(struct parse_node * node, int * looking_for_array);
struct menu * menuGetFirst(void);
struct menu * menuGetNext(struct menu * item);
void menuSetActive(struct menu * item);
void menuSetActive(struct menu * item);
void menuInstall(struct menu * item);
void parseCommandString(struct parse_node * node, const char * command);
int menuExecCommand(struct parse_node* node);
int menuPrintElem(int number, char *display);
char * elemGetOptionByIndex(struct elem * item, int index);
int printString(char * thing, int num);

char * menuGetKeyName(struct menu * item);
int menuGetElemArraySize(struct menu * item);
struct elem * menuGetElemByIndex(struct menu * item, int index);



#define LIST_MENUS \
{ \
"\0",\
"\nOther Menus - Switch to Other Menus"\
"\n%s\0",\
&ListMenus,\
NULL_PLACE_HOLDER,\
TRUE,\
TRUE,\
FALSE,\
(void*)&SetMenu,\
FALSE,\
}

#endif

