#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include "elem.h"
#include "bool_check.h"
#include "test_control.h"
#include "helpers.h"

#define PROMPT "value :"

extern struct menu command;
extern struct menu report;
extern struct menu tmac;
extern struct menu console;

extern int testReset(struct gTestStruct * test, int size);

char input_string[MAX_COMM_SIZE];
char gDisplay[BUFFER_SIZE];


#define GSIZE 10
struct gTestStruct Gtest_Array[GSIZE];



int main(void)
{      
  struct parse_node parser;
  int looking_for[] = {1,1,0};
  
  fcntl(STDIN_FILENO, F_SETFL, O_NONBLOCK);

  /* Initialize the system and setup out menus */
  menuInstall(&command);
  menuInstall(&tmac);
  menuInstall(&report);
  menuInstall(&console);
  
  // initialize
  parseNodeInit(&parser, looking_for);
  testReset(Gtest_Array, GSIZE);

  // display the menus
  menuSetActive(menuGetFirst());
  menuDisplayActive();

  while(1)
  {

    /* no chars... go home */
    if(getInputLine(input_string, MAX_COMM_SIZE, stdin, stdout))
    {    

        parseCommandString(&parser, input_string);
        menuExecCommand(&parser);
        menuDisplayActive();
    }
  }
  
  return 0;
}
