#ifndef TEST_CONTROL_H_
#define TEST_CONTROL_H_

/* Parameter Key:
 * speed - a numeral set to either 10,100,1000
 * packet_length - a numeral between 64 and 9600
 * number_packets - a numeral between 1 and 2^32
 * packet_data - 0 = random, 1 = increment
 */

enum test_codes {
    NOT_RUN=0,
    ACTIVE,
    DONE,
    ERROR,
    INTERRUPTED   
};

enum error_codes {
    SUCCESS=0,
    MON_BEFORE_GEN,
    MON_NEVER_DONE  
};

enum duplex_codes {
    HALF_DUPLEX=0,
    FULL_DUPLEX=1,
    UNKNOWN_DUPLEX   
};

enum packet_data
{
  RANDOM = 0,
  INCREMENT = 1
};


struct gTestStruct {
  struct gTestStruct * next;
// MAC params
  unsigned int macaddra_low;
  unsigned int macaddra_high;
  unsigned int macaddrb_low;
  unsigned int macaddrb_high;
  //char macaddra[6];
  //char macaddrb[6];
  unsigned int promis_mode;
//test inputs
  int test_number;
  int error_code;
  int test_control;
//char seed_value[6];
  unsigned int seed_value_low;
  unsigned int seed_value_high;
  unsigned int speed;       
  unsigned int link_duplex;     
  unsigned int packet_length;
  unsigned int random_length;
  unsigned int number_packets;
  int packet_data;
  unsigned int tech_ena;							//jier, Technology select
  unsigned int loopback_mode;						//jier, port 0 loopback mode
  unsigned int ext_loopback_mode;					//jier, External loopback option
  unsigned int port_1_loopback_mode;				//jier, port 1 loopback mode

// results
  int number;
  double time;
  unsigned int packets_sent;
  unsigned int valid_packets;
  unsigned int error_packets;
  double data_received; //this will need to be a double-width...
  double bps;
  double packets_per_second;

};

struct gTestStruct * testGetActive(void);
struct gTestStruct * testSetActive(struct gTestStruct * test);
struct gTestStruct * testGetNext(struct gTestStruct * test);
struct gTestStruct * testGetPrevious(struct gTestStruct * test);
void testResultsSet(struct gTestStruct * test);




void tsePollTest(struct gTestStruct * test);
int tseStartTest(struct gTestStruct * test);
int tseStopTest(struct gTestStruct * test);
void delay_loop(unsigned int delay_val);

#endif /*TEST_CONTROL_H_*/
