#include "bool_check.h"
#include "elem.h"
#include "unistd.h"
#include "test_control.h"
#include "helpers.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern struct gTestStruct * curr_active_test_ptr;

int displayMacAddr(char *output, void *thing)
{
    int pos =0;
    char * mac_array = (char*)thing;
    pos = convertHexToString(output, mac_array, 6*8);    
    return(pos);
}

int displayMacAddrA(char *output, void *thing)
{
    int pos=0;
    struct gTestStruct * test = *((struct gTestStruct **) thing);    

    pos=sprintf(output, "0x%04x", test->macaddra_high);
    pos+=sprintf(output+pos, "%08x", test->macaddra_low);
        
    return(pos);
}

int displayMacAddrB(char *output, void *thing)
{
    int pos=0;    
    struct gTestStruct * test = *((struct gTestStruct **) thing);    
 
    pos=sprintf(output, "0x%04x", test->macaddrb_high);
    pos+=sprintf(output+pos, "%08x", test->macaddrb_low);
    
    return(pos);
}

int valAndSetMacAddr(char * input, void * output)
{ 
  int ret_val = TRUE;
  
  unsigned int * out = (unsigned int *)output;
  
  *out = strtoul(input, 0, 16);

  return ret_val;
}



int valAndSetMacAddrA(char * input, void * thing)
{
    struct gTestStruct * test = *((struct gTestStruct **) thing);    
    int ret_val=TRUE;
    char upper[9];
    char lower[9];
    
    nullCRLF(input);
   
    if(strlen(input)>=12)
    {
    strncpy(upper, input+2, 4);
    *(upper+4)=0;
    strncpy(lower, input+6, 8);
    *(lower+8)=0;    
        
         
    if(validateHexString(input)==FALSE)
      ret_val = FALSE;
    else
    {        
      valAndSetMacAddr(upper, (void*)&test->macaddra_high);
      valAndSetMacAddr(lower, (void*)&test->macaddra_low);
    }
    }
    return (ret_val);
}

int valAndSetMacAddrB(char * input, void * thing)
{
    struct gTestStruct * test = *((struct gTestStruct **) thing);    
    int ret_val = TRUE;
    char upper[9];
    char lower[9];

    nullCRLF(input);
    
    if(strlen(input)>=12)
    { 
    strncpy(upper, input+2, 4);
    *(upper+4)=0;
    strncpy(lower, input+6, 8);
    *(lower+8)=0;    
    
    if(validateHexString(input)==FALSE)
      ret_val = FALSE;
    else
    {
      stripLeadingHex(&input);
      valAndSetMacAddr(upper, (void*)&test->macaddrb_high);
      valAndSetMacAddr(lower, (void*)&test->macaddrb_low);
    }
    }
    return(ret_val);
}

//Jier Added
//Loopback Mode
int loopback_mode_ena (char *output, void *thing)
{
  int pos;
  struct gTestStruct * test = *((struct gTestStruct **)thing);

  if (test->loopback_mode == 1)
  	pos = sprintf(output, "MAC Local Loopback"); 
  else if (test->loopback_mode == 2)
  	pos = sprintf(output, "Transceiver Serial Loopback"); 	
  else if (test->loopback_mode == 3)
  	pos = sprintf(output, "External Loopback Options"); 		
  else if (test->loopback_mode == 0)
  	pos = sprintf(output, "No Loopback"); 
  return(pos);     
}

int loopback_mode_sel (char * input, void * thing)
{
	struct menu * menu_ptr=0;
  	char * menu_name=0;	
  	int ret_val = 1;
	
	struct gTestStruct * test = *((struct gTestStruct **)thing);    

	if(strcmp(input, "MAC Local Loopback")==0)
   	{
   	   	test->loopback_mode = 1;
   	}
   	else if(strcmp(input, "Transceiver Serial Loopback")==0)
	{
   		test->loopback_mode = 2;
   	}
   	else if(strcmp(input, "External Loopback Options")==0)
	{
   		test->loopback_mode = 3;
   	}
   	else if(strcmp(input, "No Loopback")==0)				//default
	{
   		test->loopback_mode = 0;
   	}
 	else {
   	   ret_val = 0;
	}     
	
 	//External Loopback Options Menu Active
 	//Copper
	menu_ptr = menuGetFirst();
	while(menu_ptr)
	{
	    menu_name = (char*)menuGetKeyName(menu_ptr);
	    if(strcmp(menu_name, "tse_mac_menu")==0)
	        break;
	    menu_ptr = menuGetNext(menu_ptr);
	}
	if(menu_ptr)
	{
	    int size=0;
	    struct elem * item=0;
	    size=menuGetElemArraySize(menu_ptr);   
	    while(size--)
	    {
	        item = menuGetElemByIndex(menu_ptr, size);
	        if(strcmp(item->key_name, "copper_ext_loopback")==0)
	        {
	            if ((test->loopback_mode == 3) && (test->tech_ena == 0))
	                item->active = TRUE;
	            else
	                item->active = FALSE;
	           
	            break;
	        }
	    }
	}
	else
	{
	    printf("Could not find test_menu, so we're dying now...\n");
	    exit(1);
	}

    //Fiber
	menu_ptr = menuGetFirst();
	while(menu_ptr)
	{
	    menu_name = (char*)menuGetKeyName(menu_ptr);
	    if(strcmp(menu_name, "tse_mac_menu")==0)
	        break;
	    menu_ptr = menuGetNext(menu_ptr);
	}
	if(menu_ptr)
	{
	    int size=0;
	    struct elem * item=0;
	    size=menuGetElemArraySize(menu_ptr);   
	    while(size--)
	    {
	        item = menuGetElemByIndex(menu_ptr, size);
	        if(strcmp(item->key_name, "fiber_ext_loopback")==0)
	        {
	            if ((test->loopback_mode == 3) && (test->tech_ena == 1))
	                item->active = TRUE;
	            else
	                item->active = FALSE;
	           
	            break;
	        }
	    }
	}
	else
	{
	    printf("Could not find test_menu, so we're dying now...\n");
	    exit(1);
	}

  	
  	//Two Ports Loopback Menu Active
	menu_ptr = menuGetFirst();
    while(menu_ptr)
    {
        menu_name = (char*)menuGetKeyName(menu_ptr);
        if(strcmp(menu_name, "tse_mac_menu")==0)
            break;
        menu_ptr = menuGetNext(menu_ptr);
    }
    if(menu_ptr)
    {
        int size=0;
        struct elem * item=0;
        size=menuGetElemArraySize(menu_ptr);   
        while(size--)
        {
            item = menuGetElemByIndex(menu_ptr, size);
            if(strcmp(item->key_name, "two_ports_loopback")==0)
            {
                if ((test->loopback_mode == 3) && (test->ext_loopback_mode == 2))
                    item->active = TRUE;
                else
                    item->active = FALSE;
               
                break;
            }
        }
    }
    else
    {
        printf("Could not find test_menu, so we're dying now...\n");
        exit(1);
  	}
  	
  	return ret_val;  	
}

//External Loopback Options Mode
int ext_loopback_mode_ena (char *output, void *thing)
{
  int pos;
  struct gTestStruct * test = *((struct gTestStruct **)thing);

  
  	if (test->ext_loopback_mode == 0)
  	{
	  	pos = sprintf(output, "HSMC Loopback Card"); 
	}
  	else if (test->ext_loopback_mode == 1)
  	{
	  	if (test->tech_ena == 1)		//fiber
  			pos = sprintf(output, "Loopback Stub"); 	
  		else							//copper
  			pos = sprintf(output, "Loopback Stub (10/100Mbps only)");
	}
  	else if (test->ext_loopback_mode == 2)
  	{
  		pos = sprintf(output, "Two Ports Loopback"); 
	}
	else if(test->ext_loopback_mode == 3)
	{
   		pos = sprintf(output, "External PHY Loopback");
   	}
  		
  	return(pos);     
}

int ext_loopback_mode_sel (char * input, void * thing)
{
	struct menu * menu_ptr=0;
  	char * menu_name=0;	
  	int ret_val = 1;
	
	struct gTestStruct * test = *((struct gTestStruct **)thing);    

	
	if(strcmp(input, "HSMC Loopback Card")==0)				//default
   	{
   	   	test->ext_loopback_mode = 0;
   	}
   	else if ((strcmp(input, "Loopback Stub")==0) || (strcmp(input, "Loopback Stub (10/100Mbps only)")==0))		
	{
   		test->ext_loopback_mode = 1;
   	}
   	else if (strcmp(input, "Two Ports Loopback")==0)
	{
   		test->ext_loopback_mode = 2;
   	}
   	else if (strcmp(input, "External PHY Loopback")==0)
	{
   		test->ext_loopback_mode = 3;
   	}
   	else {
   	   ret_val = 0;
	}     
   
 	//External Loopback Menu Active
	menu_ptr = menuGetFirst();
    while(menu_ptr)
    {
        menu_name = (char*)menuGetKeyName(menu_ptr);
        if(strcmp(menu_name, "tse_mac_menu")==0)
            break;
        menu_ptr = menuGetNext(menu_ptr);
    }
    if(menu_ptr)
    {
        int size=0;
        struct elem * item=0;
        size=menuGetElemArraySize(menu_ptr);   
        while(size--)
        {
            item = menuGetElemByIndex(menu_ptr, size);
            if(strcmp(item->key_name, "two_ports_loopback")==0)
            {
                if (test->ext_loopback_mode == 2)
                    item->active = TRUE;
                else
                    item->active = FALSE;
               
                break;
            }
        }
    }
    else
    {
        printf("Could not find test_menu, so we're dying now...\n");
        exit(1);
  	}
  	
  	return ret_val;
}

//Two ports loopback option (Port 1)
int two_port_loopback_mode_ena (char *output, void *thing)
{
  int pos;
  struct gTestStruct * test = *((struct gTestStruct **)thing);

  if (test->port_1_loopback_mode == 0)
  	pos = sprintf(output, "Port 1 MAC RX to TX"); 
  else if (test->port_1_loopback_mode == 1)
  	pos = sprintf(output, "Port 1 PCS RX to TX"); 	
  	
  return(pos);     
}

int two_port_loopback_mode_sel (char * input, void * thing)
{
  	int ret_val = 1;

	struct gTestStruct * test = *((struct gTestStruct **)thing);    

	if (strcmp(input, "Port 1 PCS RX to TX")==0)
   	{
   	   	test->port_1_loopback_mode = 1;
   	}
   	else if (strcmp(input, "Port 1 MAC RX to TX")==0)
	{
   		test->port_1_loopback_mode = 0;
   	}
   	else {
   	   ret_val = 0;
	}     
	
	return ret_val;
}

//Promis Mode option (Port 0 and Port 1)
int promis_mode_ena (char *output, void *thing)
{
  int pos;
  struct gTestStruct * test = *((struct gTestStruct **)thing);

  if (test->promis_mode == 0)
  	pos = sprintf(output, "Disable MAC Promiscuous Mode"); 
  else if (test->promis_mode == 1)
  	pos = sprintf(output, "Enable MAC Promiscuous Mode"); 	
  	
  return(pos);     
}

int promis_mode_sel (char * input, void * thing)
{
  	int ret_val = 1;

	struct gTestStruct * test = *((struct gTestStruct **)thing);    

	if (strcmp(input, "Disable MAC Promiscuous Mode")==0)
   	{
   	   	test->promis_mode = 0;
   	}
   	else if (strcmp(input, "Enable MAC Promiscuous Mode")==0)
	{
   		test->promis_mode = 1;
   	}
   	else {
   	   ret_val = 0;
	}     
	
	return ret_val;
}

/* Menu Creation */

struct elem tsemac_menu[] =
{
  	{
  	 "macaddr_send",
  	 "\nTSE Sender MAC Address:\n"VAL_TAG"%s (hexadecimal)\0",
  	 &displayMacAddrA,
  	 &(curr_active_test_ptr),
  	 TRUE,
  	 TRUE,  
  	 (char* []){"0xEE1122334450\0","0xEE2233445560\0",USER_INPUT_TOKEN, 0},
  	 &valAndSetMacAddrA,
  	 TRUE,
  	},
  	{
  	 "macaddr_recv",
  	 "\nTSE Receiver MAC Address:\n"VAL_TAG"%s (hexadecimal)\0",
  	 &displayMacAddrB,
  	 &(curr_active_test_ptr),
  	 TRUE,
  	 TRUE,  
  	 (char* []){"0xEE1122334450\0","0xEE2233445560\0",USER_INPUT_TOKEN, 0},				
  	 &valAndSetMacAddrB,
  	 TRUE,
  	},
  	{															//jier, Promiscuous mode option
     "MAC promiscuous_mode",
     "\nMAC Promiscuous Mode Options"\
     "\n"VAL_TAG"%s",
     &promis_mode_ena,
     &curr_active_test_ptr,
     TRUE,
     TRUE,
     (char* []){"Disable MAC Promiscuous Mode\0", "Enable MAC Promiscuous Mode\0" ,0},
     &promis_mode_sel,
     TRUE,
    },
	{															//jier, Loopback mode option
     "loopback_mode",
     "\nLoopback Options"\
     "\n(Transceiver Serial Loopback is not supported in LVDS design)"\
     "\n"VAL_TAG"%s",
     &loopback_mode_ena,
     &curr_active_test_ptr,
     TRUE,
     TRUE,
     (char* []){"MAC Local Loopback\0", "Transceiver Serial Loopback\0", "External Loopback Options\0" ,"No Loopback\0" ,0},
     &loopback_mode_sel,
     TRUE,
    },
    {															//jier, Copper External loopback option
     "copper_ext_loopback",
     "\nExternal Loopback Options"\
     "\n"VAL_TAG"%s",
     &ext_loopback_mode_ena,
     &curr_active_test_ptr,
     FALSE,
     TRUE,
     (char* []){"HSMC Loopback Card\0", "Loopback Stub (10/100Mbps only)\0", "External PHY Loopback\0", "Two Ports Loopback\0", 0},
     &ext_loopback_mode_sel,
     TRUE,
    },
    {															//jier, Fiber External loopback option
     "fiber_ext_loopback",
     "\nExternal Loopback Options"\
     "\n"VAL_TAG"%s",
     &ext_loopback_mode_ena,
     &curr_active_test_ptr,
     FALSE,
     TRUE,
     (char* []){"HSMC Loopback Card\0", "Loopback Stub\0", "Two Ports Loopback\0", 0},
     &ext_loopback_mode_sel,
     TRUE,
    },      
    {															//jier, main enable setting for port 1	
     "two_ports_loopback",
     "\nTwo Ports Loopback Options"\
     "\n"VAL_TAG"%s",
     &two_port_loopback_mode_ena,
     &curr_active_test_ptr,
     FALSE,
     TRUE,
     (char* []){"Port 1 MAC RX to TX\0", "Port 1 PCS RX to TX\0", 0},
     &two_port_loopback_mode_sel,
     TRUE,
	},   
  LIST_MENUS
};
  
struct menu tmac = {
   0,
   "tse_mac_menu",
   "TSE Menu",					//jier, ori "TSE MAC Menu",
   tsemac_menu,
   sizeof(tsemac_menu)/sizeof(struct elem)
};

