

module avalon_st_loopback_sopc_wrapper (

	//Avalon MM
	CLK,
	RESET,
	ADDRESS,
	WRITE,
	READ,
	WRITEDATA,
	READDATA,
	WAITREQUEST,

	//Avalon ST TX
	TX_CLK_IN,
	TX_SOP_OUT,
	TX_DATA_OUT,
	TX_EOP_OUT,
	TX_ERR_OUT,
	TX_WREN_OUT,
	TX_RDY_IN,
	TX_MOD_OUT,		

	//Avalon ST RX
	RX_CLK_IN,
	RX_SOP_IN,
	RX_DATA_IN,
	RX_EOP_IN,
	RX_ERR_IN,
	RX_DVAL_IN,
	RX_RDY_OUT,
	RX_MOD_IN		
);

//Avalon ST TX
input			TX_CLK_IN;
output			TX_SOP_OUT;
output	[31:0]	TX_DATA_OUT;
output			TX_EOP_OUT;
output			TX_ERR_OUT;
output			TX_WREN_OUT;
input			TX_RDY_IN;
output 	[1:0]	TX_MOD_OUT;

//Avalon ST RX
input			RX_CLK_IN;
input			RX_SOP_IN;
input	[31:0]	RX_DATA_IN;
input			RX_EOP_IN;
input	[5:0]	RX_ERR_IN;
input			RX_DVAL_IN;
output			RX_RDY_OUT;
input 	[1:0]	RX_MOD_IN;

//Avalon MM
input			CLK;
input			RESET;
input	[3:0]	ADDRESS;
input			WRITE;
input			READ;
input	[15:0]	WRITEDATA;
output	[15:0]	READDATA;
output			WAITREQUEST;


avalon_st_loopback_wrapper avalon_st_loopback_wrapper_u0 (

	//Avalon MM
	.CLK(CLK),
	.RESET(RESET),
	.ADDRESS(ADDRESS),
	.WRITE(WRITE),
	.READ(READ),
	.WRITEDATA(WRITEDATA),
	.READDATA(READDATA),
	.WAITREQUEST(WAITREQUEST),

	//Avalon ST TX
	.TX_CLK_IN(TX_CLK_IN),
	.TX_CLK_OUT(),
	.TX_SOP_OUT(TX_SOP_OUT),
	.TX_DATA_OUT(TX_DATA_OUT),
	.TX_EOP_OUT(TX_EOP_OUT),
	.TX_ERR_OUT(TX_ERR_OUT),
	.TX_WREN_OUT(TX_WREN_OUT),
	.TX_MOD_OUT(TX_MOD_OUT),
	.TX_CRC_FWD_OUT(),
	.TX_RDY_IN(TX_RDY_IN),

	//Avalon ST RX
	.RX_CLK_IN(RX_CLK_IN),
	.RX_CLK_OUT(),
	.RX_SOP_IN(RX_SOP_IN),
	.RX_DATA_IN(RX_DATA_IN),
	.RX_EOP_IN(RX_EOP_IN),
	.RX_ERR_IN(RX_ERR_IN),
	.RX_DVAL_IN(RX_DVAL_IN),
	.RX_MOD_IN(RX_MOD_IN),
	.RX_RDY_OUT(RX_RDY_OUT)
);









endmodule
