//Important note, this is not a 50/50 duty cycle clock divider
`timescale 1ns/10ps

module clock_divider (
	CLK,
	CLK_ENA,
	RESET_N,

	SET_10,
		
	CLK_DIV_OUT
);

parameter	count_size = 8;

input		CLK;
input		CLK_ENA;
input		RESET_N;

input		SET_10;

output		CLK_DIV_OUT;

reg	[count_size-1:0]	count_0;
reg						CLK_DIV_OUT;

always @(posedge CLK or negedge RESET_N)
	if (!RESET_N)
		count_0 <= {count_size{1'b0}};
	else if (CLK_ENA)
		count_0 <= {count_size{1'b0}};
	else
		count_0 <= count_0 + 1'b1;
		
always @(posedge CLK or negedge RESET_N)
	if (!RESET_N) begin
		CLK_DIV_OUT <= 1'b0;
	end
	else if (SET_10) begin
		if ((count_0 == 8'h18) || (count_0 == 8'h31))
			CLK_DIV_OUT <= !CLK_DIV_OUT;
	end
	else begin
		if ((count_0 == 8'h01) || (count_0 == 8'h04))
			CLK_DIV_OUT <= !CLK_DIV_OUT;
	end

endmodule
