
module tse_ref_design_system_top (
// global signals
clk,
reset_n,

// the_triple_speed_ethernet_0
led_an_from_the_triple_speed_ethernet_0,
led_link_from_the_triple_speed_ethernet_0,
led_col_from_the_triple_speed_ethernet_0,
led_crs_from_the_triple_speed_ethernet_0,
ref_clk_to_the_triple_speed_ethernet,
rxp_to_the_triple_speed_ethernet_0,
txp_from_the_triple_speed_ethernet_0,

// the_triple_speed_ethernet_1
led_an_from_the_triple_speed_ethernet_1,
led_link_from_the_triple_speed_ethernet_1,
led_col_from_the_triple_speed_ethernet_1,
led_crs_from_the_triple_speed_ethernet_1,
rxp_to_the_triple_speed_ethernet_1,
txp_from_the_triple_speed_ethernet_1,

// the_pio
out_port_from_the_pio,
bidir_port_to_and_from_the_pio_1,
out_port_from_the_pio_2,
bidir_port_to_and_from_the_pio_3,
sfpa_txdisable,
sfpb_txdisable
);

input   		clk;
input   		ref_clk_to_the_triple_speed_ethernet;
input   		reset_n;
input   		rxp_to_the_triple_speed_ethernet_0;
input   		rxp_to_the_triple_speed_ethernet_1;
inout			bidir_port_to_and_from_the_pio_1;
inout   		bidir_port_to_and_from_the_pio_3;
output  		led_an_from_the_triple_speed_ethernet_0;
output  		led_an_from_the_triple_speed_ethernet_1;
output  		led_link_from_the_triple_speed_ethernet_0;
output  		led_link_from_the_triple_speed_ethernet_1;
output			led_col_from_the_triple_speed_ethernet_0;
output			led_col_from_the_triple_speed_ethernet_1;
output			led_crs_from_the_triple_speed_ethernet_0;
output			led_crs_from_the_triple_speed_ethernet_1;
output  		out_port_from_the_pio;
output  		out_port_from_the_pio_2;
output  		txp_from_the_triple_speed_ethernet_0;
output  		txp_from_the_triple_speed_ethernet_1;
output			sfpa_txdisable;
output 			sfpb_txdisable;

wire 			led_link_from_the_triple_speed_ethernet_0_wire;
wire 			led_link_from_the_triple_speed_ethernet_1_wire;
wire			led_an_from_the_triple_speed_ethernet_0_wire;
wire 			led_an_from_the_triple_speed_ethernet_1_wire;
wire 			led_col_from_the_triple_speed_ethernet_0_wire;
wire 			led_col_from_the_triple_speed_ethernet_1_wire;
wire			led_crs_from_the_triple_speed_ethernet_0_wire;
wire			led_crs_from_the_triple_speed_ethernet_1_wire;
        		
wire 			sys_clk;
wire			reconfig_clk;

//unuse wires
wire  			pcs_pwrdn_out_from_the_triple_speed_ethernet_0;
wire  			pcs_pwrdn_out_from_the_triple_speed_ethernet_1;

//pcs
wire  [  7: 0] 	pcs_gmii_rx_d;
wire           	pcs_gmii_rx_dv;
wire           	pcs_gmii_rx_err;
wire  [  7: 0] 	pcs_gmii_tx_d;
wire           	pcs_gmii_tx_en;
wire           	pcs_gmii_tx_err;
wire           	pcs_mii_col;
wire           	pcs_mii_crs;
wire  [  3: 0] 	pcs_mii_rx_d;
wire           	pcs_mii_rx_dv;
wire           	pcs_mii_rx_err;
wire  [  3: 0] 	pcs_mii_tx_d;
wire           	pcs_mii_tx_en;
wire           	pcs_mii_tx_err;
               	
// mac core    	
//  wire       	ena_10_from_the_triple_speed_ethernet_1;
//  wire       	eth_mode_from_the_triple_speed_ethernet_1;  
wire  [  7: 0] 	mac_gmii_tx_d;
wire           	mac_gmii_tx_en;
wire           	mac_gmii_tx_err;  
wire  [  7: 0] 	mac_gmii_rx_d;
wire           	mac_gmii_rx_dv;
wire           	mac_gmii_rx_err;  
wire  [  3: 0] 	mac_mii_tx_d;
wire           	mac_mii_tx_en;
wire           	mac_mii_tx_err; 
wire           	mac_mii_rx_col;
wire           	mac_mii_rx_crs;
wire  [  3: 0] 	mac_mii_rx_d;
wire           	mac_mii_rx_en;
wire           	mac_mii_rx_err; 
wire           	mac_rx_clk;
wire           	mac_tx_clk; 
wire           	set_10;
wire           	set_1000;
wire			pcs_tx_clk;
wire 			pcs_rx_clk;

wire			pcs_rx_clkena;
wire			pcs_tx_clkena;
  
wire			reset_tx_clk_sync;
wire			reset_rx_clk_sync;
wire			reset_tx_clk_sync_n;
wire			reset_rx_clk_sync_n;
 
wire	[16:0]  reconfig_fromgxb_gxb_u0;
wire	[16:0]	reconfig_fromgxb_gxb_u1;
wire	[3:0]	reconfig_togxb;
wire			busy;

assign	reset_tx_clk_sync = !reset_tx_clk_sync_n;
assign	reset_rx_clk_sync = !reset_rx_clk_sync_n; 
 
assign	sfpa_txdisable = 0;
assign	sfpb_txdisable = 0;

assign	led_link_from_the_triple_speed_ethernet_0 = ~led_link_from_the_triple_speed_ethernet_0_wire;
assign 	led_link_from_the_triple_speed_ethernet_1 = ~led_link_from_the_triple_speed_ethernet_1_wire;
assign 	led_an_from_the_triple_speed_ethernet_0 = ~led_an_from_the_triple_speed_ethernet_0_wire;
assign	led_an_from_the_triple_speed_ethernet_1 = ~led_an_from_the_triple_speed_ethernet_1_wire;
assign 	led_col_from_the_triple_speed_ethernet_0 = ~led_col_from_the_triple_speed_ethernet_0_wire;
assign	led_col_from_the_triple_speed_ethernet_1 = ~led_col_from_the_triple_speed_ethernet_1_wire;
assign	led_crs_from_the_triple_speed_ethernet_0 = ~led_crs_from_the_triple_speed_ethernet_0_wire;
assign	led_crs_from_the_triple_speed_ethernet_1 = ~led_crs_from_the_triple_speed_ethernet_1_wire;

//*****************************************************************************************************************************************
// Reset Synchronizer for PCS rx and tx reset
//*****************************************************************************************************************************************
//Sync reset to pcs_tx_clk
altera_std_synchronizer	#(2) reset_tx_clk_sync_u0 (
	.clk			(pcs_tx_clk), 
	.reset_n		(reset_n), 
	.din			(1'b1), 
	.dout           (reset_tx_clk_sync_n)
	);

//Sync reset to RX_CLK	
altera_std_synchronizer	#(2) reset_rx_clk_sync_u0 (
	.clk			(pcs_rx_clk), 			
	.reset_n		(reset_n), 
	.din			(1'b1), 
	.dout           (reset_rx_clk_sync_n)
	);

//*****************************************************************************************************************************************
//*****************************************************************************************************************************************
// For LVDS
//*****************************************************************************************************************************************
//*****************************************************************************************************************************************

//TSE using ALTLVDS
qsys_top	tse_ref_design_top_u0	(
	// 1) global signals:
		.clk_clk (clk), 
		.reset_reset_n (reset_n),    
		.reconfig_clk_clk (reconfig_clk),
		// the_pll
		
		.pll_phasedone_conduit_export(),    
		.pll_locked_conduit_export(), 
//*****************************
// the_triple_speed_ethernet_0
//*****************************
		.triple_speed_ethernet_0_conduit_connection_led_an 	(led_an_from_the_triple_speed_ethernet_0_wire),              
		.triple_speed_ethernet_0_conduit_connection_led_char_err(),                                              
		.triple_speed_ethernet_0_conduit_connection_led_link	(led_link_from_the_triple_speed_ethernet_0_wire),                       
		.triple_speed_ethernet_0_conduit_connection_led_disp_err (),                                                   
		.triple_speed_ethernet_0_conduit_connection_led_crs	(led_crs_from_the_triple_speed_ethernet_0_wire),           
		.triple_speed_ethernet_0_conduit_connection_led_col	(led_col_from_the_triple_speed_ethernet_0_wire),            
		
		.triple_speed_ethernet_0_conduit_connection_txp(txp_from_the_triple_speed_ethernet_0),	                 
		.triple_speed_ethernet_0_conduit_connection_rxp(rxp_to_the_triple_speed_ethernet_0),                
		.triple_speed_ethernet_0_conduit_connection_ref_clk(ref_clk_to_the_triple_speed_ethernet), 

//***************************
//  I2C
//***************************		
		.pio_0_external_connection_export(out_port_from_the_pio),  
		.pio_1_external_connection_export(bidir_port_to_and_from_the_pio_1),  
		.pio_2_external_connection_export(out_port_from_the_pio_2),     		
		.pio_3_external_connection_export(bidir_port_to_and_from_the_pio_3),
		
//*****************************
// the_pcs_sgmii_0
//*****************************
// to PCS loopback		
		
		.sgmii_pcs_0_conduit_end_gmii_rx_d(pcs_gmii_rx_d),                                                   
		.sgmii_pcs_0_conduit_end_gmii_rx_dv(pcs_gmii_rx_dv),                                                                             
		.sgmii_pcs_0_conduit_end_gmii_rx_err(pcs_gmii_rx_err),                                                                             
		.sgmii_pcs_0_conduit_end_mii_rx_d(pcs_mii_rx_d),                                                                              
		.sgmii_pcs_0_conduit_end_mii_rx_dv(pcs_mii_rx_dv),                                                                           
		.sgmii_pcs_0_conduit_end_mii_rx_err(pcs_mii_rx_err),                                                                         
		.sgmii_pcs_0_conduit_end_mii_col(pcs_mii_col),                                                                                
		.sgmii_pcs_0_conduit_end_mii_crs(pcs_mii_crs),                                                                                 
		.sgmii_pcs_0_conduit_end_gmii_tx_d(pcs_gmii_tx_d),                                                                               
		.sgmii_pcs_0_conduit_end_gmii_tx_en(pcs_gmii_tx_en),                                                                             
		.sgmii_pcs_0_conduit_end_gmii_tx_err(pcs_gmii_tx_err),                                                                           
		.sgmii_pcs_0_conduit_end_mii_tx_d(pcs_mii_tx_d),                                                                                
		.sgmii_pcs_0_conduit_end_mii_tx_err	(pcs_mii_tx_err),                                                                              
		.sgmii_pcs_0_conduit_end_mii_tx_en(pcs_mii_tx_en),     
// PCS control signal		
		.sgmii_pcs_0_conduit_end_1_tx_clk(pcs_tx_clk),                                                        
		.sgmii_pcs_0_conduit_end_1_rx_clk(pcs_rx_clk),                                                                                
		.sgmii_pcs_0_conduit_end_1_tx_clkena(pcs_tx_clkena),	                                                                             
		.sgmii_pcs_0_conduit_end_1_rx_clkena(pcs_rx_clkena),                                                                              
		.sgmii_pcs_0_conduit_end_1_reset_tx_clk(reset_tx_clk_sync),                                                                       
		.sgmii_pcs_0_conduit_end_1_reset_rx_clk(reset_rx_clk_sync),                                                                         
		
		.sgmii_pcs_0_conduit_end_2_set_10(set_10),                                                      
		.sgmii_pcs_0_conduit_end_2_set_100 (),                                                                                
		.sgmii_pcs_0_conduit_end_2_set_1000(set_1000),                                                                          
		.sgmii_pcs_0_conduit_end_2_hd_ena(),                                                                                 
		.sgmii_pcs_0_conduit_end_2_led_link	(led_link_from_the_triple_speed_ethernet_1_wire),
		.sgmii_pcs_0_conduit_end_2_led_col(led_col_from_the_triple_speed_ethernet_1_wire),                           
		.sgmii_pcs_0_conduit_end_2_led_crs(led_crs_from_the_triple_speed_ethernet_1_wire),                            
		.sgmii_pcs_0_conduit_end_2_led_an	(led_an_from_the_triple_speed_ethernet_1_wire),                           
		.sgmii_pcs_0_conduit_end_2_led_disp_err (),                                                                         
		.sgmii_pcs_0_conduit_end_2_led_char_err(),                                                                        
		                     
		
				
		.sgmii_pcs_0_conduit_end_3_txp(txp_from_the_triple_speed_ethernet_1),                             
		.sgmii_pcs_0_conduit_end_3_rxp(rxp_to_the_triple_speed_ethernet_1),	                            
		.sgmii_pcs_0_conduit_end_3_ref_clk(ref_clk_to_the_triple_speed_ethernet),                          
		                                  
		               

//*****************************
// the_triple_speed_ethernet_1
//*****************************		
		.triple_speed_ethernet_1_conduit_connection_gm_rx_d	(mac_gmii_rx_d),            
		.triple_speed_ethernet_1_conduit_connection_gm_rx_dv(mac_gmii_rx_dv),          
		.triple_speed_ethernet_1_conduit_connection_gm_rx_err(mac_gmii_rx_err),         
		.triple_speed_ethernet_1_conduit_connection_gm_tx_d	(mac_gmii_tx_d),          
		.triple_speed_ethernet_1_conduit_connection_gm_tx_en(mac_gmii_tx_en),            
		.triple_speed_ethernet_1_conduit_connection_gm_tx_err(mac_gmii_tx_err),          
		.triple_speed_ethernet_1_conduit_connection_m_rx_d(mac_mii_rx_d),             
		.triple_speed_ethernet_1_conduit_connection_m_rx_en	(mac_mii_rx_en),             
		.triple_speed_ethernet_1_conduit_connection_m_rx_err(mac_mii_rx_err),           
		.triple_speed_ethernet_1_conduit_connection_m_tx_d(mac_mii_tx_d),            
		.triple_speed_ethernet_1_conduit_connection_m_tx_en(mac_mii_tx_en),             
		.triple_speed_ethernet_1_conduit_connection_m_tx_err(mac_mii_tx_err),           
		.triple_speed_ethernet_1_conduit_connection_m_rx_col	(mac_mii_rx_col),            
		.triple_speed_ethernet_1_conduit_connection_m_rx_crs(mac_mii_rx_crs),           
		.triple_speed_ethernet_1_conduit_connection_tx_clk(mac_tx_clk),	             
		.triple_speed_ethernet_1_conduit_connection_rx_clk(mac_rx_clk),              
		.triple_speed_ethernet_1_conduit_connection_set_10(set_10),            
		.triple_speed_ethernet_1_conduit_connection_set_1000(set_1000),           
		.triple_speed_ethernet_1_conduit_connection_ena_10(),             
		.triple_speed_ethernet_1_conduit_connection_eth_mode(),          
		                                        

	
	
//*****************************
// the_pcs_loopback_wrapper_0
//*****************************	
		
		.pcs_loopback_wrapper_0_conduit_end_1000(set_1000),                        //                pcs_loopback_wrapper_0_conduit_end.1000
		.pcs_loopback_wrapper_0_conduit_end_10	(set_10),                                                            //                                             reset.reset_n
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_TX_CLK(mac_tx_clk),       // pcs_loopback_wrapper_0_pcs_loopback_mac_interface.TX_CLK
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_RX_CLK(mac_rx_clk),       //                                                  .RX_CLK
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_GMII_TX_D(mac_gmii_tx_d),    //                                                  .GMII_TX_D
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_GMII_TX_EN(mac_gmii_tx_en),   //                                                  .GMII_TX_EN
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_GMII_TX_ERR(mac_gmii_tx_err),  //                                                  .GMII_TX_ERR
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_GMII_RX_D(mac_gmii_rx_d),    //                                                  .GMII_RX_D
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_GMII_RX_DV(mac_gmii_rx_dv),   //                                                  .GMII_RX_DV
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_GMII_RX_ERR(mac_gmii_rx_err),  //                                                  .GMII_RX_ERR
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_MII_TX_D	(mac_mii_tx_d),     //                                                  .MII_TX_D
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_MII_TX_EN(mac_mii_tx_en),    //                                                  .MII_TX_EN
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_MII_TX_ERR(mac_mii_tx_err),   //                                                  .MII_TX_ERR
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_MII_RX_D(mac_mii_rx_d),     //                                                  .MII_RX_D
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_MII_RX_DV(mac_mii_rx_en),    //                                                  .MII_RX_DV
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_MII_RX_ERR(mac_mii_rx_err),   //                                                  .MII_RX_ERR
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_MII_COL(mac_mii_rx_col),      //                                                  .MII_COL
		.pcs_loopback_wrapper_0_pcs_loopback_mac_interface_MII_CRS(mac_mii_rx_crs),      //                                                  .MII_CRS
		
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_RESET_TX_CLK(), // pcs_loopback_wrapper_0_pcs_loopback_pcs_interface.RESET_TX_CLK
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_RESET_RX_CLK(), //                                                  .RESET_RX_CLK
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_TX_CLK(pcs_tx_clk),       //                                                  .TX_CLK
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_RX_CLK(pcs_rx_clk),       //                                                  .RX_CLK
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_RX_CLKENA(pcs_rx_clkena),    //                                                  .RX_CLKENA
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_TX_CLKENA(pcs_tx_clkena),    //                                                  .TX_CLKENA
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_GMII_TX_EN(pcs_gmii_tx_en),   //                                                  .GMII_TX_EN
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_GMII_TX_D(pcs_gmii_tx_d),    //                                                  .GMII_TX_D
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_GMII_TX_ERR	(pcs_gmii_tx_err),  //                                                  .GMII_TX_ERR
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_GMII_RX_D(pcs_gmii_rx_d),    //                                                  .GMII_RX_D
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_GMII_RX_DV(pcs_gmii_rx_dv),   //                                                  .GMII_RX_DV
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_GMII_RX_ERR(pcs_gmii_rx_err),  //                                                  .GMII_RX_ERR
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_MII_TX_D(pcs_mii_tx_d),     //                                                  .MII_TX_D
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_MII_TX_EN(pcs_mii_tx_en),    //                                                  .MII_TX_EN
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_MII_TX_ERR(pcs_mii_tx_err),   //                                                  .MII_TX_ERR
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_MII_RX_D(pcs_mii_rx_d),     //                                                  .MII_RX_D
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_MII_RX_DV(pcs_mii_rx_dv),    //                                                  .MII_RX_DV
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_MII_RX_ERR(pcs_mii_rx_err),   //                                                  .MII_RX_ERR
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_MII_COL	(pcs_mii_col),      //                                                  .MII_COL
		.pcs_loopback_wrapper_0_pcs_loopback_pcs_interface_MII_CRS(pcs_mii_crs)      //                                                  .MII_CRS

);

endmodule